if not defined INIT

; Warning: must be included before first use!


;  Input: A = OR numbers, DE string index, HL = number, BC = {10000,1000,100,10,1}
; Output: Write number to memory
; Pollutes: nothing
NEXTNUMBER:

    EX      AF, AF'             ;  1:4
    XOR     A                   ;  1:4
    
    INC     A                   ;  1:4
    SBC     HL, BC              ;  2:15
    JR      nc, $-3             ;  2:7/12
    
    ADD     HL, BC              ;  1:11
    DEC     A                   ;  1:4
    LD      B, A                ;  1:4    
    ADD     A, '0'              ;  2:7    
    EX      AF, AF'             ;  1:4
    
    OR      B                   ;  1:4
    RET     z                   ;  1:5/11   zatim same nuly
    
    EX      AF, AF'             ;  1:4
    LD      (DE), A             ;  1:7
    INC     DE                  ;  1:6
    EX      AF, AF'             ;  1:4
    RET                         ;  1:10


;  Input: HL
; Output: Print decimal number in HL
; Pollutes: AF, AF', BC, delete top stack
PRINT_NUM:
    PUSH    DE                  ;  1:11

    LD      DE, STRNUM          ;  3:10

    BIT     7, H                ;  2:8
    JR      z, PRINT_NUM_POS    ;  2:7/12
    
    LD      A, '-'              ;  2:7
    LD      (DE), A             ;  1:7
    INC     DE                  ;  1:6

    LD      A, L                ;  1:4
    CPL                         ;  1:4
    LD      L, A                ;  1:4
    LD      A, H                ;  1:4
    CPL                         ;  1:4
    LD      H, A                ;  1:4
    INC     HL                  ;  1:6
PRINT_NUM_POS:
    
    XOR     A                   ;  1:4
    LD      BC, 10000           ;  3:10
    CALL    NEXTNUMBER          ;  3:17
    
    LD      BC, 1000            ;  3:10
    CALL    NEXTNUMBER          ;  3:17
    
    LD      BC, 100             ;  3:10
    CALL    NEXTNUMBER          ;  3:17
    
    LD      BC, 10              ;  3:10
    CALL    NEXTNUMBER          ;  3:17
    
    LD      A, '0'              ;  2:7
    ADD     A, L                ;  1:4
    LD      (DE), A             ;  1:7
    
    EX      DE, HL              ;  1:4
    
    INC     HL                  ;  1:6
    LD      (HL), ' '           ;  2:10
    
    LD      DE, STRNUM          ;  3:10
    SBC     HL, DE              ;  2:15
    PUSH    HL                  ;  1:11
            
    LD      L, $1A              ;  2:7      Upper screen
    CALL    $1605               ;  3:17     Open channel
    
    POP     BC                  ;  1:10     Length-1 of string to print
    LD      DE, STRNUM          ;  3:10     Address of string
    CALL    $2040               ;  3:17     Print our string

    POP     HL                  ;  1:10     last DE
    POP     BC                  ;  1:10     ret
    POP     DE                  ;  1:10
    PUSH    BC                  ;  1:11     ret

    RET                         ;  1:10
STRNUM:
DB      'Dw0rkin'


; addr n --
; print n chars from addr
;  Input: HL, DE
; Output: Print decimal number in HL
; Pollutes: AF, AF', BC, DE, HL
PRINT_STRING:
    PUSH    DE                  ;  1:11     Address of string
    PUSH    HL                  ;  1:11     Length of string to print

    LD      L, $1A              ;  2:7      Upper screen
    CALL    $1605               ;  3:17     Open channel
    
    POP     BC                  ;  1:10     Length of string to print
    POP     DE                  ;  3:10     Address of string
    CALL    $203C               ;  3:17     Print our string

    RET                         ;  1:10


    
MULTIPLY:
    LD A, H         ; 1:4
    OR A            ; 1:4
    JR z, MUL_DEgr  ; 2:7/12

    LD A, D         ; 1:4
    OR A            ; 1:4
    JR z, MUL_HLgr  ; 2:7/12
    
;   overflow
    LD HL, 32767    ; 3:10
    RET             ; 1:10

MUL_HLgr:
    EX  DE, HL      ; 1:4
MUL_DEgr:
;     HL=DE*HL==DE*0L

    LD  A, L        ; 1:4
    LD  L, H        ; 1:4  HL = 0 
    
MUL_LOOP:
    SRL A           ; 2:8 divide A by 2
    JR  nc,$+3      ; 2:7/12

    ADD HL,DE       ; 1:11

    SLA E           ; 2:8
    RL  D           ; 2:8   multiply DE by 2
    
    OR  A           ; 1:4
    JR  nz,MUL_LOOP ; 2:7/12
    
    RET             ; 1:10
    
    
    
    
INIT:
    EXX
    PUSH HL
    PUSH DE
    LD  HL, SP_fce
    EXX


STOP MACRO
    POP DE
    POP HL
    EXX
    RET
ENDM


; ## Definice funkce


RUN MACRO name
    CALL name           ; 3:17   
    EX DE,HL            ; 1:4    
    EXX                 ; 1:4    
ENDM


_BEGIN MACRO name
name:
    EXX                 ; 1:4    
    POP DE              ; 1:10
    DEC HL              ; 1:6
    LD (HL),D           ; 1:7
    DEC L               ; 1:4
    LD (HL),E           ; 1:7
    EXX                 ; 1:4 
;                         7:42
ENDM


_EXIT MACRO name
    if not defined name
        .warning Parametr macra _EXIT neni definovan! Preklep? Musi byt shodny s parametrem _BEGIN.
    endif
    JP name##_end      ; 3:10
ENDM


_END MACRO name
    if not defined name
        .warning Parametr macra _END neni definovan! Preklep? Musi byt shodny s parametrem _BEGIN.
    endif
name##_end:
    EXX                 ; 1:4    
    LD E,(HL)           ; 1:7    
    INC L               ; 1:4    
    LD D,(HL)           ; 1:7    
    INC HL              ; 1:6    
    EX DE,HL            ; 1:4    
    JP (HL)             ; 1:4    
ENDM


; ## Vetveni

_IF MACRO name
name:                   ; jen pro kontrolu shodnych jmen
    LD  A, H
    OR  L
    EX  DE, HL
    POP DE
    
    jp z, name##_else
ENDM


IFZ MACRO name
name:                   ; jen pro kontrolu shodnych jmen
    jp nz, name##_else
ENDM


_ELSE MACRO name
    if not defined name
        .warning Parametr macra _ELSE neni definovan! Preklep?
    endif
    jp name##_then
name##_else:
ENDM


_THEN MACRO name
    if not defined name
        .warning Parametr macra _THEN neni definovan! Preklep? Musi byt shodny si _IF
    endif
if not defined name##_else
name##_else:
endif
name##_then:
ENDM


; ## Smycky


; stop index -- 
DO MACRO znova

    PUSH HL             ; 1:11  index
    PUSH DE             ; 1:11  stop
    
    EXX                 ; 1:4    
    POP DE              ; 1:10  stop
    DEC HL              ; 1:6    
    LD (HL),D           ; 1:7
    DEC L               ; 1:4
    LD (HL),E           ; 1:7   stop
    POP DE              ; 1:10  index
    DEC HL              ; 1:6
    LD (HL),D           ; 1:7
    DEC L               ; 1:4
    LD (HL),E           ; 1:7   index
    EXX                 ; 1:4    
    
    POP HL              ; 1:10
    POP DE              ; 1:10

znova:

ENDM


; Discard the loop-control parameters for the current nesting level.
UNLOOP MACRO
    EXX                 ; 1:4    
    INC L               ; 1:4
    INC HL              ; 1:6    
    INC L               ; 1:4
    INC HL              ; 1:6    
    EXX                 ; 1:4    
ENDM



LOOP MACRO znova

    EXX                 ; 1:4    
    
    LD E,(HL)           ; 1:7    
    INC L               ; 1:4
    LD D,(HL)           ; 1:7       DE = index   
    INC HL              ; 1:6  
    
    LD A,(HL)           ; 1:7
    SCF                 ; 1:4
    SBC A, E            ; 1:4       stop_lo - index_lo - 1
    INC L               ; 1:4
    LD A,(HL)           ; 1:7       BC = stop   
    SBC A, D            ; 1:4       stop_hi - index_hi - 1
    
    JR c, $+12          ; 2:7/12    exit

    INC DE              ; 1:6       index + 1
    
    DEC L               ; 1:4
    DEC HL              ; 1:6
    LD (HL), D          ; 1:7
    DEC L               ; 1:4
    LD (HL), E          ; 1:6
    EXX                 ; 1:6
    
    JP znova            ; 3:10

    INC HL              ; 1:6    
    EXX                 ; 1:4

ENDM


; hodnota indexu vnitrni smycky
II MACRO

    EXX                 ; 1:4    
    LD E,(HL)           ; 1:7    
    INC L               ; 1:4
    LD D,(HL)           ; 1:7   
    PUSH DE             ; 1:11
    DEC L               ; 1:4
    EXX                 ; 1:4
    
    EX  DE, HL          ; 1:4   i x1 x2 -- i x2 x1
    EX (SP), HL         ; 1:19  i x2 x1 -- x1 x2 i

ENDM


; hodnota indexu vnitrni smycky
JI MACRO

    XK

ENDM



; -- 
XDO MACRO name, index
    
    EXX                 ; 1:4    
    DEC HL              ; 1:6    
    LD (HL),high index  ; 2:10
    DEC L               ; 1:4
    LD (HL),low index   ; 2:10
    EXX                 ; 1:4    

name EQU $

ENDM

; Discard the loop-control parameters for the current nesting level.
XUNLOOP MACRO
    EXX                 ; 1:4    
    INC L               ; 1:4
    INC HL              ; 1:6    
    EXX                 ; 1:4    
ENDM

; --
XLOOP MACRO name, stop

    EXX                 ; 1:4    
    LD E,(HL)           ; 1:7    
    INC L               ; 1:4
    LD D,(HL)           ; 1:7      
    INC DE              ; 1:6       index+1

    LD A, low stop      ; 2:7
    SCF                 ; 1:4
    SBC A, E            ; 1:4       stop_lo - index_lo - 1
    LD A, high stop     ; 2:7       BC = stop   
    SBC A, D            ; 1:4       stop_hi - index_hi - 1

    JR c, $+9           ; 2:7/12    exit

    LD (HL), D          ; 1:7
    DEC L               ; 1:4
    LD (HL), E          ; 1:6
    EXX                 ; 1:6
    
    JP name             ; 3:10

    INC HL              ; 1:6 
    EXX                 ; 1:4

ENDM


; --
XLOOPPLUS MACRO name, stop, plus


    EXX                 ; 1:4
    LD  A, low plus     ; 2:7
    ADD A, (HL)         ; 1:7
    LD  E, A            ; 1:7    
    INC L               ; 1:4
    LD  A, high plus    ; 2:7
    ADC A, (HL)         ; 1:7    
    LD  (HL),A          ; 1:7    
    
    
    LD  A, E            ; 1:4
    SUB low stop        ; 2:7
    LD  A, (HL)         ; 1:7
    SUB high stop       ; 2:7
    
    JR  nc, $           ; 2:7/12
;     32,37 exit
    
    
    
    SUB A, high stop    ; 2:7
    JR  c, $+12         ; 2:7/12    exit
    JR  nz, $+6         ; 2:7/12
    
    LD  A, E            ; 1:4
    SUB low stop        ; 1:4
    JR  nc, $+6         ; 2:7/12    exit
; 26 a 36=31, 19 a 41=30   

    DEC L               ; 1:4
    JP name             ; 3:10
;                        25:94,97

    INC HL              ; 1:6 
    EXX                 ; 1:4
                        ;27:83,105



    EXX                 ; 1:4    
    LD E,(HL)           ; 1:7    
    INC L               ; 1:4
    LD D,(HL)           ; 1:7
    
    LD  BC, plus        ; 3:10
    EX  HL, DE          ; 1:4
    ADD HL, DE          ; 1:11      index+plus
    EX  HL, DE          ; 1:4
    
    LD A, low stop      ; 2:7
    SCF                 ; 1:4
    SBC A, E            ; 1:4       stop_lo - index_lo - 1
    LD A, high stop     ; 2:7       BC = stop   
    SBC A, D            ; 1:4       stop_hi - index_hi - 1

    JR c, $+9           ; 2:7/12    exit

    LD (HL), D          ; 1:7
    DEC L               ; 1:4
    LD (HL), E          ; 1:6
    EXX                 ; 1:6
    
    JP name             ; 3:10
;                        26:117

    INC HL              ; 1:6 
    EXX                 ; 1:4
                        ;28:99

ENDM



; --
XLOOPPLUS MACRO name, stop, plus

    EXX                 ; 1:4    
    LD E,(HL)           ; 1:7    
    INC L               ; 1:4
    LD D,(HL)           ; 1:7   DE = index   
    
    EX  DE, HL          ; 1:4
    
    LD  BC, plus        ; 3:10
    ADD HL, BC          ; 1:11  index+plus

    LD  BC, stop        ; 3:10    
    SBC HL, BC          ; 2:15  index-stop

    JR nc, $+11         ; 2:7/12    exit

    ADD HL, BC          ; 1:11
    
    EX  DE, HL          ; 1:4
    LD (HL), D          ; 1:7
    DEC L               ; 1:4
    LD (HL), E          ; 1:6
    EXX                 ; 1:6
    
    JP name             ; 3:10
;                        25:127

    EX  DE, HL          ; 1:4
    INC HL              ; 1:6 
    EXX                 ; 1:4
;                        28:98

ENDM


; hodnota indexu vnitrni smycky
XI MACRO

if 1 
    EXX                 ; 1:4    
    LD A,(HL)           ; 1:7   lo
    INC L               ; 1:4
    EX  AF, AF'         ; 1:4
    LD A,(HL)           ; 1:7   hi
    DEC L               ; 1:4
    EXX                 ; 1:4
    
    PUSH DE             ; 1:11
    EX DE, HL           ; 1:4
    LD  H, A            ; 1:4
    EX  AF, AF'         ; 1:4
    LD  L, A            ; 1:4
;                        12:61
else
    EXX                 ; 1:4    
    LD E,(HL)           ; 1:7    
    INC L               ; 1:4
    LD D,(HL)           ; 1:7   
    PUSH DE             ; 1:11
    DEC L               ; 1:4
    EXX                 ; 1:4
    
    EX  DE, HL          ; 1:4   i x1 x2 -- i x2 x1
    EX (SP), HL         ; 1:19  i x2 x1 -- x1 x2 i
;                         9:64
endif

ENDM


; hodnota indexu vnitrni smycky
XJ MACRO

    EXX                 ; 1:4    
    LD  E, L            ; 1:4
    LD  D, H            ; 1:4
    INC L               ; 1:4
    INC HL              ; 1:6
    LD C,(HL)           ; 1:7   lo    
    INC L               ; 1:4
    LD B,(HL)           ; 1:7   hi
    PUSH BC             ; 1:11
    EX DE, HL           ; 1:4
    EXX                 ; 1:4
    
    EX  DE, HL          ; 1:4   i x1 x2 -- i x2 x1
    EX (SP), HL         ; 1:19  i x2 x1 -- x1 x2 i
;                        13:82
ENDM



; hodnota indexu vnitrni smycky
XK MACRO

if 1
    EXX                 ; 1:4    

    LD  DE, $0004       ; 3:10
    EX  DE, HL          ; 1:4
    ADD HL, DE          ; 1:11
    
    LD C,(HL)           ; 1:7       lo    
    INC L               ; 1:4
    LD B,(HL)           ; 1:7       hi

    EX  DE, HL          ; 1:4
    PUSH BC             ; 1:11
    
    EXX                 ; 1:4    
    
    EX  DE, HL          ; 1:4   i x1 x2 -- i x2 x1
    EX (SP), HL         ; 1:19  i x2 x1 -- x1 x2 i

;                        14:89
else

    EXX                 ; 1:4    

    LD  A, $04          ; 2:7
    ADD A, L            ; 1:4
    LD  E, A            ; 1:4
    ADC A, H            ; 1:4
    SUB E               ; 1:4
    LD  D, A            ; 1:4

    LD A,(DE)           ; 1:7       lo    
    INC E               ; 1:4
    EX  AF, AF'         ; 1:4
    LD A,(DE)           ; 1:7       hi

    EXX                 ; 1:4    
    
    PUSH DE             ; 1:11
    EX  DE, HL          ; 1:4
    
    LD  H, A            ; 1:4
    EX  AF, AF'         ; 1:4    
    LD  L, A            ; 1:4
;                        18:84


endif
ENDM


; BEGIN ... flag UNTIL
; BEGIN ... flag WHILE ... REPEAT
; BEGIN ... AGAIN
;  BEGIN    WHILE           REPEAT
;  do   {   if (!) break; } while (1)
;  ( -- )
BEGIN MACRO name
name:
ENDM

;  BEGIN    WHILE           REPEAT
;  do   {   if (!) break; } while (1)
; ( flag -- )
WHILE MACRO name
    if not defined name
        .warning Parametr macra WHILE neni definovan! Preklep? Musi byt shodny s BEGIN
    endif
    LD  A, H            ; 1:4
    OR  L               ; 1:4
    EX  DE, HL          ; 1:4
    POP DE              ; 1:10
    JP  z, name##_repeat; 3:10
ENDM

;  BEGIN    WHILE           REPEAT
;  do   {   if (!) break; } while (1)
; ( -- )
REPEAT MACRO name
    if not defined name
        .warning Parametr macra REPEAT neni definovan! Preklep? Musi byt shodny s BEGIN
    endif
    JP name
name##_repeat:
ENDM
; ## Stack manipulation


; x1 x2 -- x2 x1
; prohodi vrchol zasobniku s druhou polozkou
SWAP MACRO
    EX DE, HL           ; 1:4
ENDM


; x1 -- x1 x1
; vytvori kopii vrcholu zasobniku
DUP MACRO
    PUSH DE             ; 1:11
    LD  D, H            ; 1:4
    LD  E, L            ; 1:4
ENDM

; 2dup  ( a b -- a b a b )
; over over
DUP2 MACRO
    PUSH DE             ; 1:11
    PUSH HL             ; 1:11
ENDM


; x1 -- 
; odstrani vrchol zasobniku
DROP MACRO
    EX  DE, HL
    POP DE
ENDM


; a b -- 
; odstrani 2x vrchol zasobniku
DROP2 MACRO
    POP HL
    POP DE
ENDM


; nip
; a b -- b
; swap drop ;
; drop_second
NIP MACRO
    POP DE
ENDM


; tuck
; a b -- b a b
; swap over ;
TUCK MACRO
    PUSH HL
ENDM




; x1 x2 -- x1 x2 x1
; vytvori kopii druhe polozky na zasobniku
OVER MACRO
    PUSH DE
    EX  DE, HL
ENDM


; x3 x2 x1 -- x2 x1 x3
; vyjme treti polozku a ulozi ji na vrchol
ROT MACRO
    EX DE, HL       ; x3 x1 x2
    EX (SP), HL     ; x2 x1 x3
ENDM


; x3 x2 x1 -- x1 x2 x2
; vyjme vrchol zasobniku a ulozi ho jako treti polozku
RROT MACRO
    EX (SP), HL     ; x1 x2 x3
    EX DE, HL       ; x1 x3 x2
ENDM

; ' (-- x) ( ulozi na zasobnik nasledujici polozku )
NEW MACRO num
    PUSH DE
    EX DE, HL
    LD HL, num
ENDM

; ' (x -- x) ( zmeni hodnotu top )
CHANGE_TOP MACRO num
    LD HL, num
ENDM


; ## Logic


; x1 x2 -- x
; ands the bits of x1 with x2
bit_and MACRO
    LD  A, E
    AND L
    LD  L, A
    LD  A, D
    AND H
    LD  H, A
    POP DE
ENDM


; x1 x2 -- x
; ors the bits of x1 with x2
bit_or MACRO
    LD  A, E
    OR  L
    LD  L, A
    LD  A, D
    OR  H
    LD  H, A
    POP DE
ENDM


; x1 x2 -- x
; xors the bits of x1 with x2
bit_xor MACRO
    LD  A, E
    XOR L
    LD  L, A
    LD  A, D
    XOR H
    LD  H, A
    POP DE
ENDM


; invert	
; x -- x
; flips all the bits of x
bit_neg MACRO
    LD  A, L
    CPL
    LD  L, A
    LD  A, H
    CPL
    LD  H, A
ENDM



; true
; -- x
; pushes -1 on the stack
true MACRO
    PUSH DE
    EX DE, HL
    LD HL, $ffff
ENDM

; false
; -- x
; pushes 0 on the stack
false MACRO
    PUSH De
    EX DE, HL
    LD HL, $0000
ENDM

; x -- x)
; 0 if not equal to zero, -1 if equal
eq0 MACRO
    LD  A, H
    OR  L
    LD  HL, $0000
    JR  nz, $+3
    DEC HL
ENDM


; x -- x)
; set zero flag if TOP is equal to zero
test0 MACRO
    LD  A, H
    OR  L
ENDM


; ( x2 x1 -- x2 x1 )
; set zero flag if TOP is equal to zero
test0double MACRO
    LD  A, H
    OR  L
    OR  D
    OR  E
ENDM


; =
; x1 x2 -- x
; 0 if x1 equals x2
equal MACRO
    OR  A
    SBC HL, DE
    JR  z, $+5
    LD  HL, $FFFF
    POP DE
ENDM

; <
; x1 x2 -- x
; -1 if x1 is less than x2
; -1 if DE is less than HL
less MACRO
    SCF
    SBC HL, DE
    LD  HL, $0000
    JR  c, $+3
    DEC HL
    POP DE
ENDM

    
; x1 x2 -- x
; -1 if x1 is greater than x2
; -1 if DE is greater than HL
greater MACRO
    OR  A
    SBC HL, DE
    LD  HL, $0000
    JR  nc, $+3
    DEC HL
    POP DE
ENDM

; <=
; x1 x2 -- x
less_eq MACRO
    .warning Nedodelano...
ENDM

; >=
; x1 x2 -- x
gr_eq MACRO
    .warning Nedodelano...
ENDM

; <>
; x1 x2 -- x
uneven MACRO
    .warning Nedodelano...
ENDM


; lshift	(x u -- x)	shifts x left u places
lshift MACRO
    .warning Nedodelano...
ENDM


; rshift	(x u -- x)	shifts x right u places
rshift MACRO
    .warning Nedodelano...
ENDM


; ## Arithmetic

; x1 x2 -- x
; adds x1 to x2
; soucet prvni a druhe polozky, jejich umazani a vysledek na vrchol
MACRO plus
    ADD HL, DE
    POP DE
ENDM

; x1 x2 -- x
; substracts x2 from x1
; odecet prvni polozky od druhe, jejich umazani a vysledek na vrchol
MACRO minus
    EX  DE, HL
    OR  A
    SBC HL, DE
    POP DE
ENDM
    
; absolute value of x
; x -- x
abs MACRO
    LD  A, H                    ;  1:4
    ADD A, A                    ;  1:4
    JR  nc, $9                  ;  2:7/12

    LD      A, L                ;  1:4
    CPL                         ;  1:4
    LD      L, A                ;  1:4
    LD      A, H                ;  1:4
    CPL                         ;  1:4
    LD      H, A                ;  1:4
    INC     HL                  ;  1:6
    
ENDM

; *
; x1 x2 -- x
; multiplies x1 by x2
MUL MACRO

    CALL MULTIPLY
    POP DE

ENDM

; /
; x1 x2 -- x
; divides x1 by x2
DIV MACRO
    .warning Nedodelano...
ENDM

; mod
; x1 x2 -- x
; remainder of x1 / x2
_mod_ MACRO
    .warning Nedodelano...
ENDM

; /mod	x1 x2 -- r q	remainder and quotient of division

; 1+
; x -- x
; add 1 to x
increment MACRO
    INC HL
ENDM


; 1-
; x -- x
; sub 1 to x
decrement MACRO
    DEC HL
ENDM


; 2-
; x -- x
; sub 2 to x
decrement2 MACRO
    DEC HL
    DEC HL
ENDM


; 2+
; x -- x
; add 2 to x
add2 MACRO
    INC HL
    INC HL
ENDM
    
; 2*
; x -- x
; multiplies x1 by 2
MUL2 MACRO
    ADD HL, HL      ; 1:11
ENDM


; 2/
; x -- x
; divides x1 by 2
DIV2 MACRO
    SRA H           ; 2:8   with sign
    RR L            ; 2:8
ENDM

; ## Memory access


; @
; addr -- x
; fetch 16-bit number from addr
FETCH MACRO
    LD  A, (HL) 
    INC HL
    LD  L, (HL)
    LD  H, A
ENDM


; !
; x addr --
; store 16-bit number at addr
STORE MACRO
    LD  (HL), D
    INC HL
    LD  (HL), E
    POP HL
    POP DE
ENDM
    
; ,	x --	write x to heap memory
; cell+	addr1 -- addr2	add size of cell (2) to addr
; cells	n1 -- n2	size of n1 cells (n1 * 2)
; c@	addr -- c	fetch char from addr
; c!	c addr --	store char at addr
; c,	x --	write char to heap memory
; char+	addr1 -- addr2	add size of char (1) to addr
; chars	n1 -- n2	size of n1 chars (n1)

; ## Device

; .
; x --
; print top of stack
DOT MACRO
    CALL PRINT_NUM
ENDM

; .
; x3 x2 x1 -- x
; non-destructively top of stack
SDOT MACRO
    PUSH HL                     ; x3 x1 x2 x1
    CALL PRINT_NUM              ; x3 x1 x2
    EX  DE, HL                  ; x3 x2 x1
ENDM



; type
; addr n --
; print n chars from addr
P_STRING MACRO
    CALL PRINT_STRING
    POP HL
    POP DE
ENDM


XP_STRING MACRO retezec, delka


    PUSH DE                     ;  1:11
    PUSH HL                     ;  1:11
    
    LD      L, $1A              ;  2:7      Upper screen
    CALL    $1605               ;  3:17     Open channel
    
    LD      BC, delka           ;  3:10     Length of string to print
    LD      DE, $+11            ;  3:10     Address of string
    CALL    $203C               ;  3:17     Print our string

    POP     HL                  ;  1:10
    POP     DE                  ;  1:10

    JP      $+delka+3           ;  3:10


db retezec

ENDM


CR MACRO
    LD  A, $0D                  ;
    RST  $10                    ; with 48K ROM in, this will print char in A
ENDM


; ?
; .s
; x -- x
; non-destructively prints the stack
REPRINT MACRO
    PUSH DE
    PUSH HL
    CALL PRINT_STRING
    POP HL
    POP DE
ENDM


; x3 x2 x1 -- x3 x2 x1
PRINTSTACK MACRO
    EX  (SP), HL        ; x1 x2 x3
    PUSH HL             ; x1 x3 x2 x3
    DOT                 ; x1 x3 x2
    PUSH HL             ; x1 x2 x3 x2
    DOT                 ; x1 x2 x3
    EX  (SP), HL        ; x3 x2 x1
    SDOT            
ENDM





endif
